package ProjectElectricLocomotive.src;
import java.awt.Color;

/**
 * Класс-сущность "Тепловоз"
 */
public class EntityElectricLocomotive {

    /**
     * Скорость
     */
    private int speed;

    private int wheelsCount;

    /**
     * Вес
     */
    private double weight;

    /**
     * Основной цвет
     */
    private Color bodyColor;

    /**
     * Дополнительный цвет (для дополнительных элементов)
     */
    private Color additionalColor;

    /**
     * Признак (опция) наличия "корпус"
     */
    private boolean electricHorns;

    /**
     * Признак (опция) наличия места под батарею
     */
    private boolean batteryPlacement;

    /**
     * Инициализация полей объекта-класса тепловоза
     *
     * @param speed           Скорость
     * @param weight          Вес
     * @param bodyColor       Основной цвет
     * @param additionalColor Дополнительный цвет
     * @param electricHorns   Наличие "корпуса"
     * @param batteryPlacement Наличие места под батарею
     */
    public void init(int speed, double weight, Color bodyColor, Color additionalColor, boolean electricHorns, boolean batteryPlacement) {
        this.speed = speed;
        this.weight = weight;
        this.bodyColor = bodyColor;
        this.additionalColor = additionalColor;
        this.electricHorns = electricHorns;
        this.batteryPlacement = batteryPlacement;
    }

    /**
     * Получение шага перемещения объекта
     *
     * @return Шаг перемещения
     */
    public double getStep() {
        return speed * 100 / weight;
    }

    // Геттеры и сеттеры для приватных полей
    public int getSpeed() {
        return speed;
    }

    public void setSpeed(int speed) {
        this.speed = speed;
    }

    public double getWeight() {
        return weight;
    }

    public void setWeight(double weight) {
        this.weight = weight;
    }

    public Color getBodyColor() {
        return bodyColor;
    }

    public void setBodyColor(Color bodyColor) {
        this.bodyColor = bodyColor;
    }

    public Color getAdditionalColor() {
        return additionalColor;
    }

    public void setAdditionalColor(Color additionalColor) {
        this.additionalColor = additionalColor;
    }

    public boolean isElectricHorns() {
        return electricHorns;
    }

    public void setElectricHorns(boolean electricHorns) {
        this.electricHorns = electricHorns;
    }

    public boolean isBatteryPlacement() {
        return batteryPlacement;
    }

    public void setBatteryPlacement(boolean batteryPlacement) {
        this.batteryPlacement = batteryPlacement;
    }
}
